CREATE PROCEDURE [dbo].[GetOkamochiHeader](@TEXT VARCHAR(MAX), @DATEFROM VARCHAR(15), @DATETO VARCHAR(15), @C INT OUTPUT )
AS BEGIN

--VARIABLES FOR GET ALL ORDER ASSIGNMENT DOCK, AND CYCLE ISSUE
DECLARE @DOCKCD VARCHAR(5), @RTEGRPCD VARCHAR(8), @RUNSEQ VARCHAR(3), @ALLDOCK VARCHAR(MAX), @CYCLE VARCHAR(3),
@ARRFRI VARCHAR(7), @DEPFRI VARCHAR(7), @ARR VARCHAR(7), @DEP VARCHAR(7), @DOCK_MAPPING INT

--VARIABLES FOR alter SEQUENCE NUMBER BASED ON DOCK, TERMINAL, AND ROUTE
DECLARE @FIRSTROUTE VARCHAR(10), @FIRSTTRIP VARCHAR(10), @FIRSTSTATION VARCHAR(10),
@SECONDROUTE VARCHAR(10), @SECONDTRIP VARCHAR(10), @SECONDSTATION VARCHAR(10),
@NO INT, @SDOCK VARCHAR(10), @SSDOCK VARCHAR(10)

--TEMPORARY TABLES FOR GET PHYSICAL DOCK
DECLARE @PHYDOCK TABLE (DOCKCD VARCHAR(4))
DECLARE @DOCKTABLE TABLE (DOCKCD VARCHAR(4))

--TEMPORARY TABLES FOR OKAMOCHI HEADER
DECLARE @TEMP#0 TABLE(
[R] VARCHAR(20) NULL,
[TRIP] VARCHAR(5) NULL,
[NO] VARCHAR(10) NULL,
[ROUTE] VARCHAR(20) NULL,
[ALLDOCK] VARCHAR(MAX) NULL,
[SDOCK] VARCHAR(10) NULL,
[TERMINAL] VARCHAR(10) NULL,
[ARR] VARCHAR(15) NULL,
[DEP] VARCHAR(15) NULL,
[ARRFRI] VARCHAR(15) NULL,
[DEPFRI] VARCHAR(15) NULL,
[LOGP] VARCHAR(15) NULL,
[CYCLE] VARCHAR(15) NULL,
[TEMPARRV] VARCHAR(8) NULL,
[TEMPDEPT] VARCHAR(8) NULL
)

--#GET PHYSICAL DOCK FROM PARAMETER DOCKS
-- commented fid.deny 2015-03-31 INSERT INTO @DOCKTABLE SELECT s FROM [dbo].fnSplitString(@TEXT,';')
--INSERT INTO @PHYDOCK SELECT ISNULL(A.PHYSICAL_DOCKCD,B.DOCKCD) 
--FROM TB_M_PHYSICAL_DOCK_MAPPING A JOIN @DOCKTABLE B ON A.LOGICAL_DOCKCD = B.DOCKCD OR A.PHYSICAL_DOCKCD = B.DOCKCD
--INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE

--INSERT INTO @PHYDOCK SELECT ISNULL(A.PHYSICAL_DOCKCD,@TEXT) 
--FROM TB_M_PHYSICAL_DOCK_MAPPING A WHERE A.LOGICAL_DOCKCD = @TEXT OR A.PHYSICAL_DOCKCD = @TEXT
--INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE
--COMMENTED BY ISTD.AANG 2015-04-11, CORRECTED LOGIC PHYSICAL DOCK MAPPING IF STAND ALONE

SET @DOCK_MAPPING = (SELECT COUNT(1) FROM TB_M_PHYSICAL_DOCK_MAPPING A 
WHERE A.LOGICAL_DOCKCD = @TEXT 
OR A.PHYSICAL_DOCKCD = @TEXT);

IF (@DOCK_MAPPING > 0)
BEGIN

INSERT INTO @PHYDOCK SELECT ISNULL(A.PHYSICAL_DOCKCD,@TEXT) 
FROM TB_M_PHYSICAL_DOCK_MAPPING A 
WHERE A.LOGICAL_DOCKCD = @TEXT OR A.PHYSICAL_DOCKCD = @TEXT
INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE
END

ELSE
BEGIN

INSERT INTO @PHYDOCK SELECT @TEXT
INSERT INTO @PHYDOCK SELECT DOCKCD FROM @DOCKTABLE

END


--SELECT ALL AVAILABLE HEADER BASED ON PARAMETERS (RTEDATE RANGE AND SELECTED PHYSICAL DOCK)
INSERT INTO @TEMP#0
SELECT DISTINCT
--C.RTEDATE,
C.RTEGRPCD R,
C.RUNSEQ TRIP,
NULL AS [NO],
C.RTEGRPCD + ' - ' + RIGHT(REPLICATE('0',2) + CAST(C.RUNSEQ AS VARCHAR(2)),2) [ROUTE],
NULL [ALLDOCK],
C.DOCKCD SDOCK,
D.PHYSICAL_STATION AS [TERMINAL],
CONVERT(CHAR(5), C.ARRVDATETIME, 108) [ARR],
CONVERT(CHAR(5), C.DPTDATETIME, 108) [DEP],
--CASE WHEN CONVERT(CHAR(5), B.ARRVDATETIME, 108) <> CONVERT(CHAR(5), C.ARRVDATETIME, 108) THEN
--CONVERT(CHAR(5), B.ARRVDATETIME, 108) ELSE '-' END [ARRFRI],
--CASE WHEN CONVERT(CHAR(5), B.DPTDATETIME, 108) <> CONVERT(CHAR(5), C.DPTDATETIME, 108) THEN
--CONVERT(CHAR(5), B.DPTDATETIME, 108) ELSE '-' END [DEPFRI],
NULL [ARRFRI],
NULL [DEPFRI],
C.LOGPARTNERCD LOGP,
NULL CYCLE,
CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, C.ARRVDATETIME)), 108),
CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, C.DPTDATETIME)), 108)
FROM TB_R_DCL_TLMS_DRIVER_DATA C
INNER JOIN TB_M_DELIVERY_STATION_MAPPING D 
ON D.DOOR_CD_TLMS = C.DOORCD 
   AND D.PHYSICAL_DOCK = C.DOCKCD
/*INNER JOIN TB_R_DCL_TLMS_DRIVER_DATA B
ON B.DOCKCD = C.DOCKCD 
   AND B.DOORCD <> ''
   AND DATENAME(dw,CONVERT(DATE, B.ARRVDATETIME)) = 'Friday' 
   AND DATENAME(dw,CONVERT(DATE, B.DPTDATETIME)) = 'Friday' 
   AND B.RTEGRPCD = C.RTEGRPCD 
   AND B.RUNSEQ = C.RUNSEQ*/
WHERE --C.RTEDATE >= @DATEFROM  
  --AND C.RTEDATE <= @DATETO --change "--" with --a code fid.deny 2015-04-01
  C.RTEDATE IN (@DATEFROM, @DATETO) --a
  AND C.DOORCD <> ''
  AND C.DOCKCD in (SELECT DISTINCT DOCKCD FROM @PHYDOCK)
ORDER BY [SDOCK] ASC, [TERMINAL] ASC, 
         CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, C.ARRVDATETIME)), 108) ASC,
 CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, C.DPTDATETIME)), 108) ASC

DECLARE CURR_1 CURSOR FOR
SELECT SDOCK, R, TRIP, ARR, DEP FROM @TEMP#0
OPEN CURR_1
FETCH NEXT FROM CURR_1 INTO @DOCKCD, @RTEGRPCD, @RUNSEQ, @ARR, @DEP
WHILE @@FETCH_STATUS = 0
BEGIN
SET @ALLDOCK = dbo.GetAllDock(@DOCKCD, @RTEGRPCD, @RUNSEQ)
SELECT @CYCLE = MAX(RUNSEQ) 
FROM TB_R_DCL_TLMS_DRIVER_DATA 
WHERE DOCKCD = @DOCKCD
  AND DOORCD <> '' 
  --AND RTEDATE >= @DATEFROM 5
  --AND RTEDATE < @DATETO --change "--" with "--"a code fid.deny 2015-04-01
  AND RTEDATE IN (@DATEFROM, @DATETO) --a
  AND RTEGRPCD = @RTEGRPCD

SET @ARRFRI = dbo.GetFridayArrv(@DOCKCD, @DATEFROM, @DATETO, @RTEGRPCD, @RUNSEQ, @ARR, @DEP)
SET @DEPFRI = dbo.GetFridayDept(@DOCKCD, @DATEFROM, @DATETO, @RTEGRPCD, @RUNSEQ, @ARR, @DEP)

UPDATE @TEMP#0 SET 
ALLDOCK = @ALLDOCK,
CYCLE = @CYCLE,
ARRFRI = @ARRFRI,
DEPFRI = @DEPFRI
WHERE SDOCK = @DOCKCD AND R = @RTEGRPCD AND TRIP = @RUNSEQ
FETCH NEXT FROM CURR_1 INTO @DOCKCD, @RTEGRPCD, @RUNSEQ, @ARR, @DEP
END
CLOSE CURR_1
DEALLOCATE CURR_1


SELECT TOP 1 @FIRSTROUTE = R, @FIRSTTRIP = TRIP, @FIRSTSTATION = TERMINAL, @SSDOCK = SDOCK FROM @TEMP#0

SET @NO = 0
DECLARE CURR_2 CURSOR FOR
SELECT SDOCK, R, TRIP, TERMINAL FROM @TEMP#0 ORDER BY [SDOCK] ASC, [TERMINAL] ASC, 
   CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, [ARR])), 108) ASC,
   CONVERT(VARCHAR(5), DATEADD(minute, -15, DATEADD(hh, -7, [DEP])), 108) ASC
OPEN CURR_2
FETCH NEXT FROM CURR_2 INTO @SDOCK, @SECONDROUTE, @SECONDTRIP, @SECONDSTATION
WHILE @@FETCH_STATUS = 0
BEGIN
IF((@SDOCK = @SSDOCK) AND (@SECONDSTATION = @FIRSTSTATION))
BEGIN
SET @NO = @NO + 1
END
ELSE
BEGIN
SET @NO = 1
END

UPDATE @TEMP#0 SET NO = CONVERT(VARCHAR(10),@NO) 
WHERE R = @SECONDROUTE 
  AND TRIP = @SECONDTRIP 
  AND TERMINAL = @SECONDSTATION 
  AND SDOCK = @SDOCK

SET @FIRSTROUTE = @SECONDROUTE
SET @FIRSTSTATION = @SECONDSTATION
SET @FIRSTTRIP = @SECONDTRIP
SET @SSDOCK = @SDOCK 
FETCH NEXT FROM CURR_2 INTO @SDOCK, @SECONDROUTE, @SECONDTRIP, @SECONDSTATION
END
CLOSE CURR_2
DEALLOCATE CURR_2

SELECT R, 
   TRIP, 
   [NO], 
   [ROUTE], 
   --ISNULL(ALLDOCK,'No Data in Order Assignment (' + SDOCK + ')') [ALLDOCK], 
   ALLDOCK,
   SDOCK, 
   TERMINAL, 
   ARR, 
   DEP, 
   isnull(ARRFRI,'-') AS ARRFRI, 
   isnull(DEPFRI,'-') AS DEPFRI, 
   LOGP, 
   CASE WHEN SUBSTRING(CYCLE,1,1) = '0' THEN SUBSTRING(CYCLE,2,1) ELSE CYCLE END + ' Trip/Day' [CYCLE] 
FROM @TEMP#0
WHERE ALLDOCK IS NOT NULL
ORDER BY [SDOCK] ASC, [TERMINAL] ASC, 
         CONVERT(VARCHAR(5),DATEADD(minute, -15, DATEADD(hh, -7, [ARR])), 108) ASC, 
 CONVERT(VARCHAR(5),DATEADD(minute, -15, DATEADD(hh, -7, [DEP])), 108) ASC

END

